<template>
    <div>
        <MenuBar>
            <el-icon class="cartButton" size="40" color="white" @click="() => {
                drawer = true;
            }
                ">
                <el-badge :value="cartBadge">
                    <ShoppingCart />
                </el-badge>
            </el-icon>

            <el-drawer v-model="drawer" direction="rtl" :size="drawer_size" class="color-dynamic-black">
                <template #header>
                    <h4 class="color-dynamic-black no-margin font-size-md">
                        CART
                    </h4>
                </template>
                <template #default>
                    <div>
                        <el-row>
                            <template v-for="item in drawerItems">
                                <el-col class="margin-top-sm">
                                    <div class="flex ">
                                        <img :src="item.img_url.length > 0
                                            ? `/pictures/${item.img_url}`
                                            : `/imgs/logo.jpg`
                                            " class="drawer-img" />
                                        <div class="flex flex-column margin-left-sm">
                                            <h1 class="no-margin font-size-md">
                                                {{ item.name }}
                                            </h1>
                                            <div class="flex items-space-between">
                                                <p class="no-margin color-red" style="width: 70px">
                                                    ₱{{ item.price }}
                                                </p>
                                                <p class="no-margin" style="width: 70px">
                                                    Each
                                                </p>
                                            </div>
                                            <div class="flex items-space-between">
                                                <p class="no-margin color-red" style="width: 70px">
                                                    ₱{{ item.subtotal }}
                                                </p>
                                                <p class="no-margin" style="width: 70px">
                                                    Total
                                                </p>
                                            </div>
                                        </div>


                                    </div>
                                    <div class="flex items-justify margin-top-sm">

                                        <el-input-number style="
                                        width: 100%;
                                        height: 2.5rem;
                                    " v-model.number="item.quantity" @input="updateItemQuantity(item)" :min="1" />
                                    </div>

                                    <el-button class="drawer-remove-btn margin-top-sm" size="medium"
                                        @click="removeFromCart(item)">
                                        REMOVE
                                    </el-button>
                                </el-col>
                            </template>
                        </el-row>
                    </div>
                </template>
                <template #footer>
                    <div style="
                            width: 100%;
                            height: 100px;
                            padding: 1rem;
                            display: flex;
                            flex-direction: column;
                        ">
                        <span class="flex items-justify">
                            <h1 class="no-margin margin-right-sm">
                                Sub total:
                            </h1>
                            <h3 class="no-margin">
                                ₱{{ totalSubtotal }}
                            </h3>
                        </span>

                        <el-button type="success" size="large" :disabled="totalSubtotal < 1" @click="() => {
                            router.push('/placeorder');
                        }
                            ">PROCEED TO CHECKOUT</el-button>
                    </div>
                </template>
            </el-drawer>

            <el-card>
                <div class="flex">
                    <el-input class="margin-right-sm" placeholder="Search certain food" v-model="searchQuery"
                        size="large"></el-input>

                    <el-select v-model="sortOrder" size="large">
                        <el-option label="A to Z" value="asc"></el-option>
                        <el-option label="Z to A" value="desc"></el-option>
                    </el-select>
                </div>
            </el-card>
            <el-card v-loading="loading" class="margin-top-sm">
                <div class="hero margin-bottom-md font-bebas">
                    <span class="flex flex-wrap">
                        <h1>TRY OUR DELICIOUS</h1>
                        <h1>PANCIT</h1>
                    </span>


                    <p>We are offering a door to door delivery</p>
                </div>
                <h2 v-if="!data" style="text-align: center; color: var(--el-color-info)">
                    No data
                </h2>

                <el-tabs type="border-card" size="large">
                    <el-tab-pane label="PANCIT">

                        <el-row :gutter="10" class="flex items-center items-justify flex-wrap gap-md">
                            <h2 v-if="data.length < 1" style="text-align:center; color:var(--el-color-info)">No data</h2>
                            <template v-for="item in sortedItems">

                                <el-card class="food-card margin-top-sm" :body-style="{ padding: '0px' }"
                                    :class="{ 'bounce-animation': item.animate }" v-if="item.category == 'PANCIT'">
                                    <p class="not-available" v-if="!item.available">
                                        Not available
                                    </p>

                                    <img :src="item.img_url.length > 0
                                        ? `/pictures/${item.img_url}`
                                        : `/imgs/logo.jpg`
                                        " />
                                    <p class="food-price">₱{{ item.price }}</p>

                                    <h3 class="food-name">{{ item.name }}</h3>
                                    <p class="food-description">
                                        {{ item.quantity}} PIECES
                                    </p>
                                    <p class="food-description">
                                        {{ item.description }}
                                    </p>
                                    <div class="buttons">
                                        <el-button type="success" size="large" @click="addToCart(item)"
                                            class="add-to-cart">Add to
                                            Cart</el-button>
                                    </div>
                                </el-card>
                            </template>

                        </el-row>

                    </el-tab-pane>
                    <el-tab-pane label="SILOG MEAL">

                        <el-row :gutter="10" class="flex items-center items-justify flex-wrap gap-md">
                            <h2 v-if="data.length < 1" style="text-align:center; color:var(--el-color-info)">No data</h2>
                            <template v-for="item in sortedItems">

                                <el-card class="food-card margin-top-sm" :body-style="{ padding: '0px' }"
                                    :class="{ 'bounce-animation': item.animate }" v-if="item.category == 'SILOG MEAL'">
                                    <p class="not-available" v-if="!item.available">
                                        Not available
                                    </p>

                                    <img :src="item.img_url.length > 0
                                        ? `/pictures/${item.img_url}`
                                        : `/imgs/logo.jpg`
                                        " />
                                    <p class="food-price">₱{{ item.price }}</p>

                                    <h3 class="food-name">{{ item.name }}</h3>
                                    <p class="food-description">
                                        {{ item.quantity}} PIECES
                                    </p>
                                    <p class="food-description">
                                        {{ item.description }}
                                    </p>
                                    <div class="buttons">
                                        <el-button type="success" size="large" @click="addToCart(item)"
                                            class="add-to-cart">Add to
                                            Cart</el-button>
                                    </div>
                                </el-card>
                            </template>

                        </el-row>

                    </el-tab-pane>
                    <el-tab-pane label="SHORT ORDER">

                        <el-row :gutter="10" class="flex items-center items-justify flex-wrap gap-md">
                            <h2 v-if="data.length < 1" style="text-align:center; color:var(--el-color-info)">No data</h2>
                            <template v-for="item in sortedItems">

                                <el-card class="food-card margin-top-sm" :body-style="{ padding: '0px' }"
                                    :class="{ 'bounce-animation': item.animate }" v-if="item.category == 'SHORT ORDER'">
                                    <p class="not-available" v-if="!item.available">
                                        Not available
                                    </p>

                                    <img :src="item.img_url.length > 0
                                        ? `/pictures/${item.img_url}`
                                        : `/imgs/logo.jpg`
                                        " />
                                    <p class="food-price">₱{{ item.price }}</p>

                                    <h3 class="food-name">{{ item.name }}</h3>

                                    <p class="food-description">
                                        {{ item.quantity}} PIECES
                                    </p>

                                    <p class="food-description">
                                        {{ item.description }}
                                    </p>
                                    <div class="buttons">
                                        <el-button type="success" size="large" @click="addToCart(item)"
                                            class="add-to-cart">Add to
                                            Cart</el-button>
                                    </div>
                                </el-card>
                            </template>

                        </el-row>

                    </el-tab-pane>
                    <el-tab-pane label="DRINKS">

                        <el-row :gutter="10" class="flex items-center items-justify flex-wrap gap-md">
                            <h2 v-if="data.length < 1" style="text-align:center; color:var(--el-color-info)">No data</h2>
                            <template v-for="item in sortedItems">

                                <el-card class="food-card margin-top-sm" :body-style="{ padding: '0px' }"
                                    :class="{ 'bounce-animation': item.animate }" v-if="item.category == 'DRINKS'">
                                    <p class="not-available" v-if="!item.available">
                                        Not available
                                    </p>

                                    <img :src="item.img_url.length > 0
                                        ? `/pictures/${item.img_url}`
                                        : `/imgs/logo.jpg`
                                        " />
                                    <p class="food-price">₱{{ item.price }}</p>

                                    <h3 class="food-name">{{ item.name }}</h3>
                                    <p class="food-description">
                                        {{ item.quantity}} PIECES
                                    </p>
                                    <p class="food-description">
                                        {{ item.description }}
                                    </p>
                                    <div class="buttons">
                                        <el-button type="success" size="large" @click="addToCart(item)"
                                            class="add-to-cart">Add to
                                            Cart</el-button>
                                    </div>
                                </el-card>
                            </template>

                        </el-row>

                    </el-tab-pane>
                </el-tabs>

            </el-card>
        </MenuBar>
    </div>
</template>

<style lang="scss" scoped>
@import "../../../../sass/app.scss";

.bounce-animation {
    transform: scale(1.1);
}

.drawer-remove-btn {
    cursor: pointer;
    width: 100%;
    padding: 1rem;
    background-color: #e84141;
    color: white;
    text-align: center;
}

.drawer-img {
    object-fit: cover;
    width: 100px;
    height: 100px;
    background-color: rgb(214, 214, 214);
    border-radius: 1rem;
    border: 1px solid rgb(163, 163, 163);
}

.cartButton {
    position: fixed;
    right: 0;
    bottom: 0;
    z-index: 99;
    background-color: var(--el-color-primary);
    padding: 0.8rem;
    border-radius: 1rem;
    margin-right: 1rem;
    margin-bottom: 1rem;
    cursor: pointer;
}

.hero span {
    display: flex;
}

.hero h1 {
    font-size: 80px;
    margin: 0;
    color: white;
    text-shadow: 1px 2px 1px black;
}

.hero h1:nth-child(2) {
    margin-left: 1rem;
    color: var(--el-color-primary);
}

.hero p {
    font-size: 2rem;
    margin: 0;
}

.responsive-row {
    display: flex;
    align-items: center;
    justify-content: center;
    gap: 1px;
}

.food-card {
    background-color: #f1f1f1;
    box-shadow: rgba(0, 0, 0, 0.16) 0px 3px 6px, rgba(0, 0, 0, 0.23) 0px 3px 6px;
    color: black;
    border-radius: 8px;
    padding: 20px;
    text-align: center;
    width: 250px;
    height: 360px;
    position: relative;
}

.food-card img {
    width: 100%;
    height: 200px;
    display: inline-block;
    background-color: #969696;
    object-fit: cover;
    border-radius: 8px;
    margin-bottom: 10px;
}

.food-name {
    font-size: 1.1rem;
    margin: 0px;
    text-align: left;
}

.food-description {
    font-size: 1rem;
    margin: 0px;
    margin-bottom: 10px;
    text-align: left;
    width: 450px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
}

.food-price {
    margin: 0px;
    font-size: 1.5rem;
    padding: 0.5rem;
    border: 1px solid rgb(66, 66, 66);
    border-radius: 100%;
    font-weight: bold;
    font-family: Impact, Haettenschweiler, "Arial Narrow Bold", sans-serif;
    text-align: left;
    transform: rotate(-20deg);
    position: absolute;
    top: 0;
    right: 0;
    margin-right: 1rem;
    margin-top: 1rem;
    background-color: var(--el-color-primary);
    color: white;
    text-shadow: 1px 1px 1px black;
}

.el-button {
    color: white;
}
</style>
<script setup>
import { ShoppingCart } from "@element-plus/icons-vue";
import { onMounted } from "vue";
import { ref, computed } from "vue";
import itemHandler from "../../helpers/itemHandler";
import { useRouter } from "vue-router";

const router = useRouter();
const data = ref([]);
const searchQuery = ref("");
const drawer = ref(false);
const drawer_size = ref("25%");
const cartBadge = ref(0);
const drawerItems = ref([]);
const totalSubtotal = ref();

const { loading, fetchItem } = itemHandler;
const URL_fetch_items = "/api/user/item";

onMounted(async () => {
    fetchItem(URL_fetch_items, data);
    updateCartBadge();
    updateDrawerItems();
    updateTotalSubTotal();
});

const updateItemQuantity = (item) => {
    const cartItemsString = sessionStorage.getItem("cart");
    if (cartItemsString) {
        const cartItems = JSON.parse(cartItemsString);
        const existingItemIndex = cartItems.findIndex(
            (cartItem) => cartItem.id === item.id
        );
        if (existingItemIndex !== -1) {
            cartItems[existingItemIndex].quantity = item.quantity;

            cartItems[existingItemIndex].subtotal =
                cartItems[existingItemIndex].quantity *
                cartItems[existingItemIndex].price;

            sessionStorage.setItem("cart", JSON.stringify(cartItems));

            let totalSubtotal = 0;
            cartItems.forEach((cartItem) => {
                totalSubtotal += cartItem.subtotal;
            });

            sessionStorage.setItem("totalSubtotal", totalSubtotal);

            updateCartBadge();
            updateDrawerItems();
            updateTotalSubTotal();
        }
    }
};

const addToCart = (item) => {
    item.animate = true;
    setTimeout(() => {
        item.animate = false;
    }, 200);

    const existingCartItemsString = sessionStorage.getItem("cart");
    let cartItems = [];

    if (existingCartItemsString) {
        cartItems = JSON.parse(existingCartItemsString);
    }

    const existingItemIndex = cartItems.findIndex(
        (cartItem) => cartItem.id === item.id
    );

    if (existingItemIndex !== -1) {
        cartItems[existingItemIndex].quantity += 1;
        cartItems[existingItemIndex].subtotal =
            cartItems[existingItemIndex].quantity *
            cartItems[existingItemIndex].price;
    } else {
        item.quantity = 1;
        item.subtotal = item.price;
        cartItems.push(item);
    }

    const cartItemsString = JSON.stringify(cartItems);
    sessionStorage.setItem("cart", cartItemsString);

    let totalSubtotal = 0;
    cartItems.forEach((cartItem) => {
        totalSubtotal += cartItem.subtotal;
    });

    sessionStorage.setItem("totalSubtotal", totalSubtotal);

    updateCartBadge();
    updateDrawerItems();
    updateTotalSubTotal();
};

const removeFromCart = (item) => {
    const cartItemsString = sessionStorage.getItem("cart");
    if (cartItemsString) {
        let cartItems = JSON.parse(cartItemsString);

        const existingItemIndex = cartItems.findIndex(
            (cartItem) => cartItem.id === item.id
        );

        if (existingItemIndex !== -1) {
            cartItems.splice(existingItemIndex, 1);

            sessionStorage.setItem("cart", JSON.stringify(cartItems));

            let totalSubtotal = 0;
            cartItems.forEach((cartItem) => {
                totalSubtotal += cartItem.subtotal;
            });

            sessionStorage.setItem("totalSubtotal", totalSubtotal);

            updateCartBadge();
            updateDrawerItems();
            updateTotalSubTotal();
        }
    }
};

const updateCartBadge = () => {
    let cartItemsString = sessionStorage.getItem("cart") || 0;
    let cartItems = JSON.parse(cartItemsString);

    cartBadge.value = cartItems.length;
};

const updateDrawerItems = () => {
    drawerItems.value = JSON.parse(sessionStorage.getItem("cart") || null);
};

const updateTotalSubTotal = () => {
    totalSubtotal.value =
        sessionStorage.getItem("totalSubtotal", totalSubtotal) || 0;
};

const sortOrder = ref("asc");
const availability = ref("all");
const sortedItems = computed(() => {
    const filteredSortedItems = [...filteredItems.value].sort((a, b) => {
        const nameA = a.name.toLowerCase();
        const nameB = b.name.toLowerCase();
        if (sortOrder.value === "asc") {
            return nameA.localeCompare(nameB);
        } else {
            return nameB.localeCompare(nameA);
        }
    });

    if (availability.value === "available") {
        return filteredSortedItems.filter((item) => item.available);
    } else if (availability.value === "not_available") {
        return filteredSortedItems.filter((item) => !item.available);
    }

    return filteredSortedItems;
});

const filteredItems = computed(() => {
    if (!searchQuery.value) {
        return data.value;
    } else {
        return data.value.filter((item) =>
            item.name.toLowerCase().includes(searchQuery.value.toLowerCase())
        );
    }
});

const mediaQuery = window.matchMedia("(max-width: 768px)");
const handleViewportChange = (mq) => {
    if (mq.matches) {
        drawer_size.value = "100%";
    } else {
        drawer_size.value = "25%";
    }
};
handleViewportChange(mediaQuery);
mediaQuery.addEventListener("change", handleViewportChange);
</script>
